﻿Imports System.Net.Http
Imports Windows.UI.Core
Imports Bing.Maps
Imports Windows.UI
Imports Windows.UI.Popups

Public NotInheritable Class MainPage
    Inherits Page
    Private myAddressLatitude As String
    Private myAddressLongitude As String
    Private myCoreDispacher As CoreDispatcher
    Private Async Sub okButton_Click(sender As Object, e As RoutedEventArgs) Handles okButton.Click
        If addressTextBox.Text <> String.Empty Then
            Dim addressUri = String.Format("http://www.geocoding.jp/api/?v=1.1&q={0}", addressTextBox.Text)
            Dim myHttpClient As New HttpClient
            Dim myResponse = Await myHttpClient.GetStringAsync(New Uri(addressUri, UriKind.Absolute))
            Dim xmldoc As XElement = XElement.Parse(myResponse)
            myAddressLatitude = xmldoc.Descendants("coordinate").Elements("lat").Value
            myAddressLongitude = xmldoc.Descendants("coordinate").Elements("lng").Value
            myMap.Children.Clear()
            DataShow()
        Else
            Exit Sub
        End If
    End Sub

    Private Sub DataShow()
        myMap.Children.Clear()
        Dim myPin As New Image
        Dim myLocation As Location
        With myPin
            .Width = 96
            .Height = 96
            .Source = New BitmapImage(New Uri("ms-appx:///Image/pin.png", UriKind.Absolute))
        End With
        myLocation = New Location(CDbl(myAddressLatitude), CDbl(myAddressLongitude))
        MapLayer.SetPosition(myPin, myLocation)
        myMap.Children.Add(myPin)
        myMap.SetView(myLocation, 14)

        Dim myStackPanel As New StackPanel
        myStackPanel.Margin = New Thickness(5)
        myStackPanel.Background = New SolidColorBrush(Colors.Navy)
        myStackPanel.Visibility = Xaml.Visibility.Collapsed

        Dim myAddressTextBlock As New TextBlock
        myAddressTextBlock.Foreground = New SolidColorBrush(Colors.Red)
        myAddressTextBlock.Width = 400
        myAddressTextBlock.TextWrapping = TextWrapping.Wrap
        myAddressTextBlock.FontSize = 24
        myAddressTextBlock.Padding = New Thickness(5)
        myAddressTextBlock.Text = "【場所】=" & addressTextBox.Text

        myStackPanel.Children.Add(myAddressTextBlock)

        MapLayer.SetPosition(myStackPanel, New Location(CDbl(myAddressLatitude), CDbl(myAddressLongitude)))
        myMap.Children.Add(myStackPanel)

        AddHandler myPin.Tapped, Sub()
                                     myStackPanel.Visibility = Xaml.Visibility.Visible
                                 End Sub

        AddHandler myStackPanel.Tapped, Sub()
                                            myStackPanel.Visibility = Xaml.Visibility.Collapsed
                                        End Sub
    End Sub
End Class
